<template>
  <ckeditor
    v-model="editorData"
    type="classic"
    :editors="editors"
    :config="editorConfig"
    :upload-adapter="UploadAdapter"
  />
</template>

<script>
import VueCkeditor from 'vue-ckeditor5';
import ClassicEditor from '@ckeditor/ckeditor5-build-classic';
import api from '@/config/api';

export default {
  name: 'VEditor',
  components: {
    ckeditor: VueCkeditor.component,
  },
  props: {
    clearContent: {
      type: Boolean,
      required: true,
    },
  },
  data() {
    return {
      editorData: '',
      editors: {
        classic: ClassicEditor,
      },
      editorConfig: {
        toolbar: ['heading', '|', 'bold', 'italic', 'link', 'bulletedList', 'numberedList', 'imageUpload', 'blockQuote', 'insertTable', 'undo', 'redo'],
      },
      UploadAdapter(loader) {
        this.loader = loader;
        this.upload = () => new Promise((resolve, reject) => {
          this.loader.file.then(async (file) => {
            const formData = new FormData();
            formData.append('image', file);

            const res = await api.post('/files', formData);

            resolve({ default: res.data.photo });
          }).catch(error => reject(error));
        });
        this.abort = () => {
          console.log('Abort upload.');
        };
      },
    };
  },
  watch: {
    clearContent(val) {
      if (val) {
        this.editorData = '';
      }
    },
    editorData() {
      this.$emit('content-changed', this.editorData);
    },
  },
};
</script>

<style lang="stylus" scoped>

</style>
